﻿using Discord.WebSocket;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.WebSockets;
using System.Threading.Tasks;

namespace DiscoBot
{
    interface IModule
    {
        Dictionary<string,Func<SocketMessage, string[], Task>> Commands { get; set; }
        string Name { get; set; }
        void Initialize();
        Task OnNewWebSocketAsync(WebSocket ws, TaskCompletionSource<object> tcs);
        string ConcatParameters(string[] parameters)
        {
            string str = "";
            for (var i = 0; i < parameters.Length; ++i)
            {
                var s = parameters[i];
                if (str == "")
                {
                    str += s;
                }
                else
                {
                    str += " " + s;
                }
            }
            return str;
        }
    }
}
