﻿using Microsoft.EntityFrameworkCore;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Threading.Tasks;

namespace DiscoBot.bdaygreet
{
    public class BDayGreetContext : DbContext
    {
        private ulong guildId;
        public DbSet<BDayUser> BDays { get; set; }

        public BDayGreetContext(ulong guildId)
        {
            this.guildId = guildId;
        }

        protected override void OnConfiguring(DbContextOptionsBuilder optionsBuilder)
        {
            optionsBuilder.UseSqlite("Data Source=" + guildId + "-bdaygreet.db");
        }
    }

    public class BDayUser
    {
        [Key]
        public string DiscordTag { get; set; }
        public DateTimeOffset BirthDate { get; set; }
        public ulong Channel { get; set; }
        public DateTimeOffset NextGreet { get; set; }

    }
}
