﻿using Microsoft.EntityFrameworkCore;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Threading.Tasks;

namespace DiscoBot.rss
{
    public class RssContext : DbContext
    {
        private ulong guildId;
        public DbSet<RssFeed> RssFeeds { get; set; }

        public RssContext(ulong guildId)
        {
            this.guildId = guildId;
        }

        protected override void OnConfiguring(DbContextOptionsBuilder optionsBuilder)
        {
            optionsBuilder.UseSqlite("Data Source=" + guildId + "-rss.db");
        }
    }

    public class RssFeed
    {
        [Key]
        public string Name { get; set; }
        public string Url { get; set; }
        public ulong Channel { get; set; }
        public TimeSpan CheckInterval { get; set; }
        public DateTimeOffset LastChecked { get; set; }

    }
}
